/**
 * <copyright>
 * </copyright>
 *
 * $Id: COBOLElementImpl.java,v 1.2.4.1 2005/10/28 04:37:27 akkina Exp $
 */
package com.ibm.etools.cobol.impl;

import com.ibm.etools.cobol.COBOL88Element;
import com.ibm.etools.cobol.COBOLClassifier;
import com.ibm.etools.cobol.COBOLComposedType;
import com.ibm.etools.cobol.COBOLElement;
import com.ibm.etools.cobol.COBOLElementInitialValue;
import com.ibm.etools.cobol.COBOLFixedLengthArray;
import com.ibm.etools.cobol.COBOLPackage;
import com.ibm.etools.cobol.COBOLSourceText;

import com.ibm.etools.tdlang.TDLangClassifier;
import com.ibm.etools.tdlang.TDLangPackage;

import com.ibm.etools.tdlang.impl.TDLangElementImpl;

import com.ibm.etools.typedescriptor.InstanceTDBase;
import com.ibm.etools.typedescriptor.TypeDescriptorPackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Element</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.ibm.etools.cobol.impl.COBOLElementImpl#getLevel <em>Level</em>}</li>
 *   <li>{@link com.ibm.etools.cobol.impl.COBOLElementImpl#getRedefined <em>Redefined</em>}</li>
 *   <li>{@link com.ibm.etools.cobol.impl.COBOLElementImpl#getIsFiller <em>Is Filler</em>}</li>
 *   <li>{@link com.ibm.etools.cobol.impl.COBOLElementImpl#getIsExternal <em>Is External</em>}</li>
 *   <li>{@link com.ibm.etools.cobol.impl.COBOLElementImpl#getIsGlobal <em>Is Global</em>}</li>
 *   <li>{@link com.ibm.etools.cobol.impl.COBOLElementImpl#getContains <em>Contains</em>}</li>
 *   <li>{@link com.ibm.etools.cobol.impl.COBOLElementImpl#getSharedType <em>Shared Type</em>}</li>
 *   <li>{@link com.ibm.etools.cobol.impl.COBOLElementImpl#getArray <em>Array</em>}</li>
 *   <li>{@link com.ibm.etools.cobol.impl.COBOLElementImpl#getGroup <em>Group</em>}</li>
 *   <li>{@link com.ibm.etools.cobol.impl.COBOLElementImpl#getSource <em>Source</em>}</li>
 *   <li>{@link com.ibm.etools.cobol.impl.COBOLElementImpl#getInitial <em>Initial</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class COBOLElementImpl extends TDLangElementImpl implements COBOLElement {
	/**
	 * The default value of the '{@link #getLevel() <em>Level</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLevel()
	 * @generated
	 * @ordered
	 */
	protected static final String LEVEL_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getLevel() <em>Level</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLevel()
	 * @generated
	 * @ordered
	 */
	protected String level = LEVEL_EDEFAULT;

	/**
	 * The default value of the '{@link #getRedefined() <em>Redefined</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRedefined()
	 * @generated
	 * @ordered
	 */
	protected static final Boolean REDEFINED_EDEFAULT = new Boolean(false);

	/**
	 * The cached value of the '{@link #getRedefined() <em>Redefined</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRedefined()
	 * @generated
	 * @ordered
	 */
	protected Boolean redefined = REDEFINED_EDEFAULT;

	/**
	 * The default value of the '{@link #getIsFiller() <em>Is Filler</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIsFiller()
	 * @generated
	 * @ordered
	 */
	protected static final Boolean IS_FILLER_EDEFAULT = new Boolean(false);

	/**
	 * The cached value of the '{@link #getIsFiller() <em>Is Filler</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIsFiller()
	 * @generated
	 * @ordered
	 */
	protected Boolean isFiller = IS_FILLER_EDEFAULT;

	/**
	 * The default value of the '{@link #getIsExternal() <em>Is External</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIsExternal()
	 * @generated
	 * @ordered
	 */
	protected static final Boolean IS_EXTERNAL_EDEFAULT = new Boolean(false);

	/**
	 * The cached value of the '{@link #getIsExternal() <em>Is External</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIsExternal()
	 * @generated
	 * @ordered
	 */
	protected Boolean isExternal = IS_EXTERNAL_EDEFAULT;

	/**
	 * The default value of the '{@link #getIsGlobal() <em>Is Global</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIsGlobal()
	 * @generated
	 * @ordered
	 */
	protected static final Boolean IS_GLOBAL_EDEFAULT = new Boolean(false);

	/**
	 * The cached value of the '{@link #getIsGlobal() <em>Is Global</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIsGlobal()
	 * @generated
	 * @ordered
	 */
	protected Boolean isGlobal = IS_GLOBAL_EDEFAULT;

	/**
	 * The cached value of the '{@link #getContains() <em>Contains</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getContains()
	 * @generated
	 * @ordered
	 */
	protected EList contains = null;

	/**
	 * The cached value of the '{@link #getSharedType() <em>Shared Type</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSharedType()
	 * @generated
	 * @ordered
	 */
	protected COBOLClassifier sharedType = null;

	/**
	 * The cached value of the '{@link #getArray() <em>Array</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getArray()
	 * @generated
	 * @ordered
	 */
	protected COBOLFixedLengthArray array = null;

	/**
	 * The cached value of the '{@link #getSource() <em>Source</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSource()
	 * @generated
	 * @ordered
	 */
	protected COBOLSourceText source = null;

	/**
	 * The cached value of the '{@link #getInitial() <em>Initial</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInitial()
	 * @generated
	 * @ordered
	 */
	protected EList initial = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected COBOLElementImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return COBOLPackage.eINSTANCE.getCOBOLElement();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLevel() {
		return level;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLevel(String newLevel) {
		String oldLevel = level;
		level = newLevel;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, COBOLPackage.COBOL_ELEMENT__LEVEL, oldLevel, level));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Boolean getRedefined() {
		return redefined;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRedefined(Boolean newRedefined) {
		Boolean oldRedefined = redefined;
		redefined = newRedefined;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, COBOLPackage.COBOL_ELEMENT__REDEFINED, oldRedefined, redefined));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Boolean getIsFiller() {
		return isFiller;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIsFiller(Boolean newIsFiller) {
		Boolean oldIsFiller = isFiller;
		isFiller = newIsFiller;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, COBOLPackage.COBOL_ELEMENT__IS_FILLER, oldIsFiller, isFiller));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Boolean getIsExternal() {
		return isExternal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIsExternal(Boolean newIsExternal) {
		Boolean oldIsExternal = isExternal;
		isExternal = newIsExternal;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, COBOLPackage.COBOL_ELEMENT__IS_EXTERNAL, oldIsExternal, isExternal));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Boolean getIsGlobal() {
		return isGlobal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIsGlobal(Boolean newIsGlobal) {
		Boolean oldIsGlobal = isGlobal;
		isGlobal = newIsGlobal;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, COBOLPackage.COBOL_ELEMENT__IS_GLOBAL, oldIsGlobal, isGlobal));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getContains() {
		if (contains == null) {
			contains = new EObjectContainmentEList(COBOL88Element.class, this, COBOLPackage.COBOL_ELEMENT__CONTAINS);
		}
		return contains;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public COBOLClassifier getSharedType() {
		if (sharedType != null && sharedType.eIsProxy()) {
			COBOLClassifier oldSharedType = sharedType;
			sharedType = (COBOLClassifier)eResolveProxy((InternalEObject)sharedType);
			if (sharedType != oldSharedType) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, COBOLPackage.COBOL_ELEMENT__SHARED_TYPE, oldSharedType, sharedType));
			}
		}
		return sharedType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public COBOLClassifier basicGetSharedType() {
		return sharedType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetSharedType(COBOLClassifier newSharedType, NotificationChain msgs) {
		COBOLClassifier oldSharedType = sharedType;
		sharedType = newSharedType;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, COBOLPackage.COBOL_ELEMENT__SHARED_TYPE, oldSharedType, newSharedType);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSharedType(COBOLClassifier newSharedType) {
		if (newSharedType != sharedType) {
			NotificationChain msgs = null;
			if (sharedType != null)
				msgs = ((InternalEObject)sharedType).eInverseRemove(this, COBOLPackage.COBOL_CLASSIFIER__TYPED_ELEMENT, COBOLClassifier.class, msgs);
			if (newSharedType != null)
				msgs = ((InternalEObject)newSharedType).eInverseAdd(this, COBOLPackage.COBOL_CLASSIFIER__TYPED_ELEMENT, COBOLClassifier.class, msgs);
			msgs = basicSetSharedType(newSharedType, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, COBOLPackage.COBOL_ELEMENT__SHARED_TYPE, newSharedType, newSharedType));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public COBOLFixedLengthArray getArray() {
		return array;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetArray(COBOLFixedLengthArray newArray, NotificationChain msgs) {
		COBOLFixedLengthArray oldArray = array;
		array = newArray;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, COBOLPackage.COBOL_ELEMENT__ARRAY, oldArray, newArray);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setArray(COBOLFixedLengthArray newArray) {
		if (newArray != array) {
			NotificationChain msgs = null;
			if (array != null)
				msgs = ((InternalEObject)array).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - COBOLPackage.COBOL_ELEMENT__ARRAY, null, msgs);
			if (newArray != null)
				msgs = ((InternalEObject)newArray).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - COBOLPackage.COBOL_ELEMENT__ARRAY, null, msgs);
			msgs = basicSetArray(newArray, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, COBOLPackage.COBOL_ELEMENT__ARRAY, newArray, newArray));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public COBOLComposedType getGroup() {
		if (eContainerFeatureID != COBOLPackage.COBOL_ELEMENT__GROUP) return null;
		return (COBOLComposedType)eContainer;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setGroup(COBOLComposedType newGroup) {
		if (newGroup != eContainer || (eContainerFeatureID != COBOLPackage.COBOL_ELEMENT__GROUP && newGroup != null)) {
			if (EcoreUtil.isAncestor(this, newGroup))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eContainer != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newGroup != null)
				msgs = ((InternalEObject)newGroup).eInverseAdd(this, COBOLPackage.COBOL_COMPOSED_TYPE__ELEMENT, COBOLComposedType.class, msgs);
			msgs = eBasicSetContainer((InternalEObject)newGroup, COBOLPackage.COBOL_ELEMENT__GROUP, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, COBOLPackage.COBOL_ELEMENT__GROUP, newGroup, newGroup));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public COBOLSourceText getSource() {
		if (source != null && source.eIsProxy()) {
			COBOLSourceText oldSource = source;
			source = (COBOLSourceText)eResolveProxy((InternalEObject)source);
			if (source != oldSource) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, COBOLPackage.COBOL_ELEMENT__SOURCE, oldSource, source));
			}
		}
		return source;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public COBOLSourceText basicGetSource() {
		return source;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSource(COBOLSourceText newSource) {
		COBOLSourceText oldSource = source;
		source = newSource;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, COBOLPackage.COBOL_ELEMENT__SOURCE, oldSource, source));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getInitial() {
		if (initial == null) {
			initial = new EObjectResolvingEList(COBOLElementInitialValue.class, this, COBOLPackage.COBOL_ELEMENT__INITIAL);
		}
		return initial;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
				case COBOLPackage.COBOL_ELEMENT__TD_LANG_SHARED_TYPE:
					if (tdLangSharedType != null)
						msgs = ((InternalEObject)tdLangSharedType).eInverseRemove(this, TDLangPackage.TD_LANG_CLASSIFIER__TD_LANG_TYPED_ELEMENT, TDLangClassifier.class, msgs);
					return basicSetTdLangSharedType((TDLangClassifier)otherEnd, msgs);
				case COBOLPackage.COBOL_ELEMENT__INSTANCE_TD_BASE:
					if (instanceTDBase != null)
						msgs = ((InternalEObject)instanceTDBase).eInverseRemove(this, TypeDescriptorPackage.INSTANCE_TD_BASE__LANGUAGE_INSTANCE, InstanceTDBase.class, msgs);
					return basicSetInstanceTDBase((InstanceTDBase)otherEnd, msgs);
				case COBOLPackage.COBOL_ELEMENT__SHARED_TYPE:
					if (sharedType != null)
						msgs = ((InternalEObject)sharedType).eInverseRemove(this, COBOLPackage.COBOL_CLASSIFIER__TYPED_ELEMENT, COBOLClassifier.class, msgs);
					return basicSetSharedType((COBOLClassifier)otherEnd, msgs);
				case COBOLPackage.COBOL_ELEMENT__GROUP:
					if (eContainer != null)
						msgs = eBasicRemoveFromContainer(msgs);
					return eBasicSetContainer(otherEnd, COBOLPackage.COBOL_ELEMENT__GROUP, msgs);
				default:
					return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
				case COBOLPackage.COBOL_ELEMENT__TD_LANG_SHARED_TYPE:
					return basicSetTdLangSharedType(null, msgs);
				case COBOLPackage.COBOL_ELEMENT__INSTANCE_TD_BASE:
					return basicUnsetInstanceTDBase(msgs);
				case COBOLPackage.COBOL_ELEMENT__CONTAINS:
					return ((InternalEList)getContains()).basicRemove(otherEnd, msgs);
				case COBOLPackage.COBOL_ELEMENT__SHARED_TYPE:
					return basicSetSharedType(null, msgs);
				case COBOLPackage.COBOL_ELEMENT__ARRAY:
					return basicSetArray(null, msgs);
				case COBOLPackage.COBOL_ELEMENT__GROUP:
					return eBasicSetContainer(null, COBOLPackage.COBOL_ELEMENT__GROUP, msgs);
				default:
					return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
				case COBOLPackage.COBOL_ELEMENT__GROUP:
					return ((InternalEObject)eContainer).eInverseRemove(this, COBOLPackage.COBOL_COMPOSED_TYPE__ELEMENT, COBOLComposedType.class, msgs);
				default:
					return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return ((InternalEObject)eContainer).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case COBOLPackage.COBOL_ELEMENT__NAME:
				return getName();
			case COBOLPackage.COBOL_ELEMENT__TD_LANG_SHARED_TYPE:
				if (resolve) return getTdLangSharedType();
				return basicGetTdLangSharedType();
			case COBOLPackage.COBOL_ELEMENT__INSTANCE_TD_BASE:
				if (resolve) return getInstanceTDBase();
				return basicGetInstanceTDBase();
			case COBOLPackage.COBOL_ELEMENT__LEVEL:
				return getLevel();
			case COBOLPackage.COBOL_ELEMENT__REDEFINED:
				return getRedefined();
			case COBOLPackage.COBOL_ELEMENT__IS_FILLER:
				return getIsFiller();
			case COBOLPackage.COBOL_ELEMENT__IS_EXTERNAL:
				return getIsExternal();
			case COBOLPackage.COBOL_ELEMENT__IS_GLOBAL:
				return getIsGlobal();
			case COBOLPackage.COBOL_ELEMENT__CONTAINS:
				return getContains();
			case COBOLPackage.COBOL_ELEMENT__SHARED_TYPE:
				if (resolve) return getSharedType();
				return basicGetSharedType();
			case COBOLPackage.COBOL_ELEMENT__ARRAY:
				return getArray();
			case COBOLPackage.COBOL_ELEMENT__GROUP:
				return getGroup();
			case COBOLPackage.COBOL_ELEMENT__SOURCE:
				if (resolve) return getSource();
				return basicGetSource();
			case COBOLPackage.COBOL_ELEMENT__INITIAL:
				return getInitial();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case COBOLPackage.COBOL_ELEMENT__NAME:
				setName((String)newValue);
				return;
			case COBOLPackage.COBOL_ELEMENT__TD_LANG_SHARED_TYPE:
				setTdLangSharedType((TDLangClassifier)newValue);
				return;
			case COBOLPackage.COBOL_ELEMENT__INSTANCE_TD_BASE:
				setInstanceTDBase((InstanceTDBase)newValue);
				return;
			case COBOLPackage.COBOL_ELEMENT__LEVEL:
				setLevel((String)newValue);
				return;
			case COBOLPackage.COBOL_ELEMENT__REDEFINED:
				setRedefined((Boolean)newValue);
				return;
			case COBOLPackage.COBOL_ELEMENT__IS_FILLER:
				setIsFiller((Boolean)newValue);
				return;
			case COBOLPackage.COBOL_ELEMENT__IS_EXTERNAL:
				setIsExternal((Boolean)newValue);
				return;
			case COBOLPackage.COBOL_ELEMENT__IS_GLOBAL:
				setIsGlobal((Boolean)newValue);
				return;
			case COBOLPackage.COBOL_ELEMENT__CONTAINS:
				getContains().clear();
				getContains().addAll((Collection)newValue);
				return;
			case COBOLPackage.COBOL_ELEMENT__SHARED_TYPE:
				setSharedType((COBOLClassifier)newValue);
				return;
			case COBOLPackage.COBOL_ELEMENT__ARRAY:
				setArray((COBOLFixedLengthArray)newValue);
				return;
			case COBOLPackage.COBOL_ELEMENT__GROUP:
				setGroup((COBOLComposedType)newValue);
				return;
			case COBOLPackage.COBOL_ELEMENT__SOURCE:
				setSource((COBOLSourceText)newValue);
				return;
			case COBOLPackage.COBOL_ELEMENT__INITIAL:
				getInitial().clear();
				getInitial().addAll((Collection)newValue);
				return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case COBOLPackage.COBOL_ELEMENT__NAME:
				setName(NAME_EDEFAULT);
				return;
			case COBOLPackage.COBOL_ELEMENT__TD_LANG_SHARED_TYPE:
				setTdLangSharedType((TDLangClassifier)null);
				return;
			case COBOLPackage.COBOL_ELEMENT__INSTANCE_TD_BASE:
				unsetInstanceTDBase();
				return;
			case COBOLPackage.COBOL_ELEMENT__LEVEL:
				setLevel(LEVEL_EDEFAULT);
				return;
			case COBOLPackage.COBOL_ELEMENT__REDEFINED:
				setRedefined(REDEFINED_EDEFAULT);
				return;
			case COBOLPackage.COBOL_ELEMENT__IS_FILLER:
				setIsFiller(IS_FILLER_EDEFAULT);
				return;
			case COBOLPackage.COBOL_ELEMENT__IS_EXTERNAL:
				setIsExternal(IS_EXTERNAL_EDEFAULT);
				return;
			case COBOLPackage.COBOL_ELEMENT__IS_GLOBAL:
				setIsGlobal(IS_GLOBAL_EDEFAULT);
				return;
			case COBOLPackage.COBOL_ELEMENT__CONTAINS:
				getContains().clear();
				return;
			case COBOLPackage.COBOL_ELEMENT__SHARED_TYPE:
				setSharedType((COBOLClassifier)null);
				return;
			case COBOLPackage.COBOL_ELEMENT__ARRAY:
				setArray((COBOLFixedLengthArray)null);
				return;
			case COBOLPackage.COBOL_ELEMENT__GROUP:
				setGroup((COBOLComposedType)null);
				return;
			case COBOLPackage.COBOL_ELEMENT__SOURCE:
				setSource((COBOLSourceText)null);
				return;
			case COBOLPackage.COBOL_ELEMENT__INITIAL:
				getInitial().clear();
				return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case COBOLPackage.COBOL_ELEMENT__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case COBOLPackage.COBOL_ELEMENT__TD_LANG_SHARED_TYPE:
				return tdLangSharedType != null;
			case COBOLPackage.COBOL_ELEMENT__INSTANCE_TD_BASE:
				return isSetInstanceTDBase();
			case COBOLPackage.COBOL_ELEMENT__LEVEL:
				return LEVEL_EDEFAULT == null ? level != null : !LEVEL_EDEFAULT.equals(level);
			case COBOLPackage.COBOL_ELEMENT__REDEFINED:
				return REDEFINED_EDEFAULT == null ? redefined != null : !REDEFINED_EDEFAULT.equals(redefined);
			case COBOLPackage.COBOL_ELEMENT__IS_FILLER:
				return IS_FILLER_EDEFAULT == null ? isFiller != null : !IS_FILLER_EDEFAULT.equals(isFiller);
			case COBOLPackage.COBOL_ELEMENT__IS_EXTERNAL:
				return IS_EXTERNAL_EDEFAULT == null ? isExternal != null : !IS_EXTERNAL_EDEFAULT.equals(isExternal);
			case COBOLPackage.COBOL_ELEMENT__IS_GLOBAL:
				return IS_GLOBAL_EDEFAULT == null ? isGlobal != null : !IS_GLOBAL_EDEFAULT.equals(isGlobal);
			case COBOLPackage.COBOL_ELEMENT__CONTAINS:
				return contains != null && !contains.isEmpty();
			case COBOLPackage.COBOL_ELEMENT__SHARED_TYPE:
				return sharedType != null;
			case COBOLPackage.COBOL_ELEMENT__ARRAY:
				return array != null;
			case COBOLPackage.COBOL_ELEMENT__GROUP:
				return getGroup() != null;
			case COBOLPackage.COBOL_ELEMENT__SOURCE:
				return source != null;
			case COBOLPackage.COBOL_ELEMENT__INITIAL:
				return initial != null && !initial.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (level: ");
		result.append(level);
		result.append(", redefined: ");
		result.append(redefined);
		result.append(", isFiller: ");
		result.append(isFiller);
		result.append(", isExternal: ");
		result.append(isExternal);
		result.append(", isGlobal: ");
		result.append(isGlobal);
		result.append(')');
		return result.toString();
	}

} //COBOLElementImpl
