// ****************************************************************
//
//   IBM Confidential
//   OCO Source Materials
//   <<com.ibm.etools.cobol.preference.ui>>
//   (C) Copyright IBM Corp. 2001, 2004 - All Rights Reserved.
//   US Government Users Restricted Rights - Use, duplication or disclosure
//   restricted by GSA ADP Schedule Contract with IBM Corp.
//
// ****************************************************************

package com.ibm.etools.cobol.preference.ui.common;
public class HelpContextIds {
	private static final String copyright = "(c) Copyright IBM Corporation 2001,2004.";


	public static final String PREFIX_ID = "com.ibm.etools.cobol.preference.ui.";
	
	// COBOL Preference Page
	public static final String COBOL_PP_PREFERENCEPAGE    		  	= PREFIX_ID+"pcob0010";
	public static final String COBOL_PP_PLATFORM_SELECTION    	  	= PREFIX_ID+"pcob0015";
	public static final String COBOL_PP_CODEPAGE	    		  	= PREFIX_ID+"pcob0020";
	public static final String COBOL_PP_FLOATING_POINT_FORMAT	  	= PREFIX_ID+"pcob0030";
	public static final String COBOL_PP_ENDIAN_BIG				  	= PREFIX_ID+"pcob0040";
	public static final String COBOL_PP_ENDIAN_LITTLE			  	= PREFIX_ID+"pcob0050";
	public static final String COBOL_PP_REMOTE_ENDIAN_BIG		  	= PREFIX_ID+"pcob0060";
	public static final String COBOL_PP_REMOTE_ENDIAN_LITTLE	  	= PREFIX_ID+"pcob0070";
	public static final String COBOL_PP_EXT_DECIMAL_SIGN_ASCII	  	= PREFIX_ID+"pcob0080";
	public static final String COBOL_PP_EXT_DECIMAL_SIGN_EDBCDIC  	= PREFIX_ID+"pcob0090";
	public static final String COBOL_PP_EXT_DECIMAL_SIGN_CEDBCDIC 	= PREFIX_ID+"pcob0100";
	public static final String COBOL_PP_TRUNC_STD				  	= PREFIX_ID+"pcob0110";
	public static final String COBOL_PP_TRUNC_OPT				  	= PREFIX_ID+"pcob0120";
	public static final String COBOL_PP_TRUNC_BIN				  	= PREFIX_ID+"pcob0130";
	public static final String COBOL_PP_NUMPROC_PFD				  	= PREFIX_ID+"pcob0140";
	public static final String COBOL_PP_NUMPROC_NOPFD			  	= PREFIX_ID+"pcob0150";
	public static final String COBOL_PP_NUMPROC_MIG				  	= PREFIX_ID+"pcob0160";
	public static final String COBOL_PP_NSYMBOL_DBCS			  	= PREFIX_ID+"pcob0170";
	public static final String COBOL_PP_NSYMBOL_NATIONAL		  	= PREFIX_ID+"pcob0180";
	public static final String COBOL_PP_QUOTE_DOUBLE			  	= PREFIX_ID+"pcob0190";
	public static final String COBOL_PP_QUOTE_SINGLE			  	= PREFIX_ID+"pcob0200";
	public static final String COBOL_PP_COMPILE_TIME_LOCALE 		= PREFIX_ID+"pcob0210";
	public static final String COBOL_PP_ASCII_CODEPAGE 				= PREFIX_ID+"pcob0220";
	public static final String COBOL_PP_ERROR_MSGS_LANG 			= PREFIX_ID+"pcob0230";	
	public static final String COBOL_PP_CURRENCY 					= PREFIX_ID+"pcob0240";
	public static final String COBOL_PP_SOSI 						= PREFIX_ID+"pcob0250";
	public static final String COBOL_PP_COLLSEQ_LOCALE				= PREFIX_ID+"pcob0260";
	public static final String COBOL_PP_COLLSEQ_EBCDIC				= PREFIX_ID+"pcob0270";
	public static final String COBOL_PP_COLLSEQ_BIN					= PREFIX_ID+"pcob0280";
	public static final String COBOL_PP_NCOLLSEQ_LOCALE				= PREFIX_ID+"pcob0290";
	public static final String COBOL_PP_NCOLLSEQ_BIN				= PREFIX_ID+"pcob0300";
	public static final String COBOL_PP_FILE_EXTENSION_SUPPORT		= PREFIX_ID+"pcob0310";
	
}

